; Quelltext zum Spiel "B-Bert"
; geschrieben in C64 BASIC V2
; als Beitrag zur "20 Zeilen BASIC Compo" im Forum64.de:
; http://www.forum64.de/wbb3/index.php?page=Thread&threadID=23294
; Simon Stelling (ssdsa), 07/2008.

; Wettbewerbsregeln:
; "Ziel ist es ein Spiel in 20 Zeilen BASIC Code unter zu bringen.
;  Keine Assembler-DATAs, kein Nachladen,
;  ins ROM SYSen ist allerdings gestattet. 
;  Das ganze muss mit jedem C64 (also auch SX64 und C128 im C64 Modus)
;  laufen, einzig eine 1541 und bis zu 2 Joysticks sind angeschlossen.
; 
;  Die BASIC-Zeilen drfen lnger als 80 Zeichen sein.
;  Es muss nicht zwingend mglich sein, die Zeilen am C64
;  ber den BASIC-Editor einzugeben. Es muss aber BASIC sein.
;
;  Es ist beispielsweise auch erlaubt, Zeichenstze in REMs reinzupoken
;  und zu benutzen, aber nur, solange da kein Assembler bei rumkommt."
; 
; Deadline: 5. Juli 2008 um 23:00.

; Assembler: "C64ASM.py" (version "V1.0.007 2008-06-26")

; ========================================================================

; PETSCII

DEFINE CHR_WHITE         $05
DEFINE CHR_SHIFT_DISABLE $08
DEFINE CHR_CR            $0D
DEFINE CHR_SHIFT_OUT     $0E
DEFINE CHR_CURSOR_DOWN   $11
DEFINE CHR_REVERSE_ON    $12
DEFINE CHR_HOME          $13
DEFINE CHR_DEL           $14
DEFINE CHR_RED           $1C
DEFINE CHR_CURSOR_RIGHT  $1D
DEFINE CHR_GREEN         $1E
DEFINE CHR_BLUE          $1F
DEFINE SEMICOLON         $3B
DEFINE CHR_ORANGE        $81
DEFINE CHR_BLACK         $90
DEFINE CHR_CURSOR_UP     $91
DEFINE CHR_REVERSE_OFF   $92
DEFINE CHR_CLEAR_SCREEN  $93
DEFINE CHR_INS           $94
DEFINE CHR_BROWN         $95
DEFINE CHR_LIGHT_RED     $96
DEFINE CHR_GRAY1         $97
DEFINE CHR_GRAY2         $98
DEFINE CHR_LIGHT_GREEN   $99
DEFINE CHR_LIGHT_BLUE    $9A
DEFINE CHR_GRAY3         $9B
DEFINE CHR_PURPLE        $9C
DEFINE CHR_CURSOR_LEFT   $9D
DEFINE CHR_YELLOW        $9E
DEFINE CHR_CYAN          $9F



; ========================================================================

; Einige Tricks:

; ========================================================================

; POKE46,64:CLR legt Beginn der Variablen nach $4000.
; Dadurch hat man $2000-$3FFF frei fr Grafikdaten (Charset, Sprites).

; ========================================================================

; POKE 211,SP :POKE 214, ZE: SYS 58640
; Aufruf einer Systemroutine:
; positioniert den Cursor auf die angegebene Spalten- (SP) und Zeilennummer (ZE)
; (Habe ich hier nicht gebraucht.)

; ========================================================================

; "Springe in Zeile x an die Stelle y"-Anweisung durch Ausnutzung von CONT:
; Der Trick wre, vorher an $3D/$3E (61/62) die Stelle zu Poken wo man im Basicprogramm
; einspringen will. An $3B/3C (59/60) die entsprechende Zeilennummer damit der Interpreter
; nicht durcheinander kommt weil z.B. GOTO darauf zugreift.
; ==> Diese tolle Idee funktioniert so nicht, weil der BASIC-Interpreter
; den Inhalt von $3D/$3E nach jedem(!) BASIC-Befehl neu setzt!
;
; ABER: Wenn wir nicht den BASIC-Befehl CONT benutzen, sondern mittels SYS
; direkt in die CONT-Routine springen, dann geht es!
;         $A857/43095:   Perform [cont]
;        A857: D0 17     BNE $A870
;        A859: A2 1A     LDX #$1A
;        A85B: A4 3E     LDY $3E       ; Pointer: BASIC Statement for CONT
;        A85D: D0 03     BNE $A862
;        A85F: 4C 37 A4  JMP $A437     ; Error Routine
;        A862: A5 3D     LDA $3D       ; Pointer: BASIC Statement for CONT
; --> Hier mit SYS einspringen:
;        A864: 85 7A     STA $7A       ; Pointer: Current Byte of BASIC Text
;        A866: 84 7B     STY $7B       ; Pointer: Current Byte of BASIC Text
;        A868: A5 3B     LDA $3B       ; Previous BASIC Line number
;        A86A: A4 3C     LDY $3C       ; Previous BASIC Line number
;        A86C: 85 39     STA $39       ; Current BASIC Line number
;        A86E: 84 3A     STY $3A       ; Current BASIC Line number
;        A870: 60        RTS
;
; Also A und Y setzen und dann SYS $A864!
; D.h.:
; POKE780,low: POKE782,high: SYS43108
;
;
; Oder einfach die aktuelle Adresse in CHRGET ($73) verndern,
; sie steht in $7A/$7B (122/123).
; Vorsicht, dort steht die aktuelle Adresse. Sie wird um eins erhht,
; bevor das nchste Zeichen gelesen wird.
; Durch ndern des Low-Bytes der Adresse kann man problemlos
; vor oder zurck springen, solange man dabei keine Page-Grenze
; berschreitet:
; POKE122, <neues Low-Byte>
;
; ========================================================================

; Besonderheiten beim Daten entpacken:
; Folgen von zu kopierenden Bytes (Anzahl als 1. Byte angegeben; mindestens 1)
; wechseln sich ab mit einer Anzahl zu berspringender Bytes (kann auch 0 sein,
;   da Anzahl+1 angegeben werden muss, um so Nullbytes im BASIC-Source zu vermeiden).
; Ein BASIC-Zeilenwechsel (d.h. eine 34 im Source)
; ist nur an der Stelle erlaubt, an der die Anzahl zu berspringender Bytes
; gelesen wird. Daher ist es nicht mglich, genau 34-1 = 33 Bytes zu berspringen.
; Falls Folgen von Nullen o.. vorkommen, sollte man den Zielbereich vorher
; komplett mit Nullen fllen, und dann diese Bereiche beim Entpacken
; wie oben beschrieben berspringen.

; ========================================================================

DEFINE file_start $0801

PC file_start-2
 .wo file_start  ; generate low- and high-byte of start address as first 2 bytes of file

 
adr_basic_line_0:
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 10  ; line number

    .basic ' h$ = "'
    .asc '{13, 13, SHIFT_DISABLE, SHIFT_OUT}'
    .asc '{GRAY3}***{WHITE} B-Bert {GRAY3}***'
    .asc '{13, GRAY3}'
    .asc 'A mini-game written in BASIC'
    .by 13
    .asc 'in only 20 lines'
    .by 13
    .asc 'for the {WHITE}20 Zeilen BASIC Compo{GRAY3}'
    .by 13
    .asc 'of Forum64.de'
    .asc '{13, 13, LIGHT_BLUE}'
    .basic '"'

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 20  ; line number

    .basic ' c$ = "{13, 13, SHIFT_DISABLE, SHIFT_OUT, GRAY3}'
    .asc 'Written by{YELLOW} Simon Stelling {GRAY3}(ssdsa)'
    .by 13
    .asc '07/2008'
    .by 13, 13
    .asc 'Contact: '
    .by 13
    .asc ' simon.stelling@gmx.de{13, 13, LIGHT_BLUE}"'
    .basic ' : CLR :::::::::::::::::::::::::::::::: '

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 30  ; line number

; PRINT to $2000:
        .basic ' POKE648,32: '
        .basic ' PRINT"{CLEAR_SCREEN, SHIFT_DISABLE}" :  '
;;        .basic ' POKE 8960, 31 : '
        .basic ' POKE 8960, 26 : '
; Display VIC screen at $2000 to show progress to the waiting player:
;;      .basic ' POKE 53272, 132 : '
        .basic ' POKE 53272, 136 : POKE 53265, 91 :'

; PRINT to $0400:
        .basic ' POKE648,4 : '

; Set start of Variables to $4000:
        .basic 'POKE46,64:CLR:'
; Now we can use memory up to $3FFF for our graphics data
; and won't collide with the BASIC variables.

; Disable interrupts and enable Charset ROM:
        .basic " POKE 56334,0 : POKE 1,51 : "

; Copy CBM Charset to $2000:
        .basic " FOR i = 8192 TO 8703 : POKE i, PEEK(i+45056) : NEXT : "

; Disable Charset ROM and re-enable interrupts:
        .basic " POKE 1,55 : POKE 56334,1 : "

; Depack graphics data:
            .basic "a=34 : n=5 : s="
            .ascnum4 gfx_source_in_basic
            .basic ": d=8408 : "
            .basic " FOR i = 1 TO 4 : "
            .basic "   v = PEEK(s) : s=s+1 : "
            .basic "   FOR j = 1 TO v : "
            .basic "     b = PEEK(s) : s=s+1 : "
            .basic "     POKE d, b + (b < n) : d=d+1 : "
            .basic "   NEXT : "
            .basic "   v = PEEK(s) : "
            .basic "   s = s - 10*(v=a) : "
            .basic "   v = PEEK(s) : s=s+1 : "
            .basic "   d = d + v - 1 : "
            .basic " NEXT "

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 40  ; line number

; PRINT initial game board:
        .basic 'PRINT"{ORANGE,CLEAR_SCREEN,DOWN,DOWN,DOWN}":'

        .basic 'FOR y=0 TO 9: '

; Color all lines in color 8 except for last board line (Y=9) in color 12:
        .basic 'POKE 646, 8-4*(y=9):'

; Print first row of current board line:
        .basic 'PRINT SPC(18-2*y) "{91,92}{REVERSE_ON}" a$ "{REVERSE_OFF}{93,94}":'
        .basic 'a$ = a$ + "{93,94}{123,124}" : '

; Skip printing of second row in last board line (Y=9):
        .basic "POKE 122,"
        .ascnum2 <(adr_basic_dontskip_line2)
        .basic " - (y=9)*"
        .ascnum2 <(adr_basic_skip_line2)-<(adr_basic_dontskip_line2)
adr_basic_dontskip_line2:
        .asc ":"

; Print second row of current board line:
        .basic 'b$ = b$ + "{95,36,165,166}":'
        .basic 'PRINT SPC(18-2*y) "{REVERSE_ON}" b$ "{REVERSE_OFF}" '
adr_basic_skip_line2:
        .basic ':'

    ASSERT >(adr_basic_dontskip_line2) = >(adr_basic_skip_line2)

        .basic ' NEXT : '

; Clear basic variables we used so far because they were only necessary for one-time init:
        .basic " CLR : "

; Current color of game board fields are stored in C(x,y):
        .basic ' DIM c(9,9) : '

; Z = 122
        .basic ' z = 122 : '

; Initial sprite pointer for sprite #0:
        .basic ' sp = 136 : '

adr_basic_restart_attract:
        .basic ":"

; Set sprite pointer for sprite #0:
        .basic 'POKE 2040,sp:'

;;; Set sprite pointer for sprite #1:
;;        .basic 'POKE 2041,138:'

; Prepare VIC, set VIC registers to initial values:

; PRINT to $D000:
        .basic 'POKE 648,208:'

        .basic 'PRINT"{HOME}'

;       ; $D000, $D001 / 53248, 53249: initial position of Sprite #0: 172, 72
;       .by CHR_REVERSE_ON
;       .by $2C
;       .by CHR_REVERSE_OFF
;       .by $68

        ; $D000, $D001 / 53248, 53249: initial position of Sprite #0: (skip)
        .asc '{RIGHT,RIGHT}'

        ; $D002 ... $D00F / 53248 ... 53263: (skip)
        .asc '{RIGHT,RIGHT,RIGHT,RIGHT,RIGHT,RIGHT,RIGHT,RIGHT,RIGHT,RIGHT,RIGHT,RIGHT,RIGHT,RIGHT}'

        ; $D010 / 53264: 0
        .asc "@"

        ; $D011 / 53265: 91
        .by 91+32

        ; $D012 ... $D014 / 53266 ... 53268: (skip)
        .asc '{RIGHT,RIGHT,RIGHT}'

        ; $D015 / 53269: all Sprites off.
        .asc "@"
        ; $D016 / 53270: 8
        .asc "h"
        ; $D017 / 53271: Sprite Y expansion: 0
        .asc "@"
        ; $D018 / 53272: 24
        .asc "y"

        ; $D019 .. $D01B / 53273 ... 53275: (skip)
        .asc '{RIGHT,RIGHT,RIGHT}'

        ; $D01C / 53276: Sprite #0 and #1 multicolor on, others off
        .asc "c"
        ; $D01D / 53277: Sprite X expansion: 0
        .asc "@"

        ; $D01E .. $D01F / 53278 ... 53279: (skip)
        .asc '{RIGHT,RIGHT}'

        ; $D020 .. $D024 / 53280 ... 53284: colors: 12, 12, 0, 11, 15
        .asc "ll@ko"
        ; $D025 .. $D027 / 53285 ... 53287: colors: 10, 9, 5
        .asc "jie"
        ; $D028 / 53288: colors: 7
        .asc "g"

        .asc '"'

; PRINT to $0400:
        .basic ' : POKE 648,4 '

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 50  ; line number

; Prepare BASIC variables Y$(y) and X$(x) for values of y = 0 ... 8 and x = 0 ... y
; and T$:
        .basic ' FOR y=0 TO 8: y$(y) = "{HOME,DOWN,DOWN}" : '
        .basic ' FOR i=0 TO y: y$(y) = y$(y) + "{DOWN,DOWN}" : NEXT : '
        .basic ' FOR i=0 TO 8-y: y$(y) = y$(y) + "{RIGHT,RIGHT}" : NEXT : '
        .basic ' x$(y+1) = x$(y) + "{RIGHT,RIGHT,RIGHT,RIGHT}" : NEXT : '
        .basic ' t$ = "ses!{DOWN,LEFT,LEFT,LEFT,LEFT}g*p!" '

; Now you can re-color a game board field by using POKE646,c:PRINT Y$(y)X$(x)T$;

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 60  ; line number

; Joystick in port #2
        .basic ' p = 56320 : '

; Init status bar:
        .basic ' PRINT"{HOME,BROWN,DOWN}lifes: 3~~~~level: 1~~~~score: 0~~~~~~~" : '

; Print "Press Fire to Play":
        .basic ' PRINT"{DOWN,YELLOW} joystick port #2 - press fire to play" : '

        .basic ' c$ = "{HOME,DOWN,DOWN,DOWN,GRAY1}~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ " : '

; PRINT to $3000:
        .basic 'POKE 648,48 '

        .basic ' :::::::::::::::::::::: '   ; Waste some bytes

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 70

adr_basic_branch_attract:
        .asc ':'

;  Re-Color random game board field in random color:
        .basic " y = INT(RND(1)*13) : "
        ; We don't want to use colors 11, 12 and 15,
        ; so we map 0 ... 12 to 0 ... 10, 13, 14.
        .basic " POKE 646,y - 2*(y > 10) : "
        .basic " y = INT(RND(1)*9) : x = INT(RND(1)*(y+1)) : "
        .basic " PRINT y$(y) x$(x) t$ "
        .by SEMICOLON

        .basic " : POKE z,"
        .ascnum1 <(adr_basic_branch_attract)
        .basic " - ((PEEK(p) AND 16) = 0)*"
        .ascnum2 <(adr_basic_dontbranch_attract)-<(adr_basic_branch_attract)

adr_basic_dontbranch_attract:
        .basic " : "

    ASSERT >(adr_basic_dontbranch_attract) = >(adr_basic_branch_attract)

; Initial lifes: 3 
        .basic ' li = 3 '

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 80

; Initial level: 1 
        .basic ' le = 1 : '

; Initial Score is 0. We use "sc" for that.
        .basic " sc = 0 "

; Initial Highscore is 0. We use "hi" for that.

basic_adr_start_next_level:
        .basic " : "

; PRINT to $0400:
        .basic ' POKE 648,4 : '

; Clear "Press Fire to Play" (or other messages, e.g. "Level completed"):
        .basic ' PRINT c$ : '

; PRINT to $3000:
        .basic ' POKE 648,48 : '

; Choose different colors for game board fiels for different levels:
; We use "c0" and "cs" for those colors.
        .basic " c0 = PEEK( "
        .ascnum4 basic_adr_level_colors
        .basic " + (le AND 7)) : cs = c0 / 16 : "

; Paint all game board fields with initial color:
        .basic ' POKE 646, c0 : ' ; set initial color here
        .basic ' FOR y = 0 TO 8 : FOR x = 0 TO y : PRINT y$(y)x$(x)t$'
        .by SEMICOLON
        .basic ' : '
        .basic ' c(x,y) = 0 : '
        .basic ' NEXT : NEXT '

; Initial number of colored game board fiels is 0.
; We use "cf" for that.
        .basic " : cf = 0 "

basic_adr_restart_after_life_lost:
        .basic ' : '

; Player game board X and Y coordinates are 0, 0.
; We use "px" and "py" for that.
        .basic " px = 0 : py = 0 : "

; Kugel #1 game board X and Y initial coordinates are 0, -9.
; Y <= -3 means that Kugel #1 is invisible.
; Y = -2 and Y = -1 mean that Kugel #1 is above the board, going to fall onto the board.
; Y = 0 means that Kugel #1 is on the top field on the game board.
; Y = 9 means that Kugel #1 has fallen off the board.
; We use "kx" and "ky" for that.
        .basic " kx = 0 : ky = -9 : "  ; Adjust here: delay before Kugel #1 appears

;  Turn Sprite #0 on; all others off.
        .basic " POKE53269,1 : " 


; Forever:
        .basic " FOR i = 0 TO 5 : i = 0 "

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 90

; Handle Kugel #1:
; Check if Kugel #1 is invisible:
        .basic " POKE z, "
        .ascnum3 <(adr_basic_skip_kugel1_invisible)
        .basic " + (ky < -2)*"
    ASSERT >(adr_basic_skip_kugel1_invisible) = >(adr_basic_dontskip_kugel1_invisible)
        .ascnum3 <(adr_basic_skip_kugel1_invisible)-<(adr_basic_dontskip_kugel1_invisible)
adr_basic_dontskip_kugel1_invisible:
        .asc ":"

        .basic " ky = ky - (ky < -3) : "

; Check if Kugel #1 can be made visible:
        .basic " POKE z, "
        .ascnum3 <(adr_basic_skip_kugel1_make_visible)
        .basic " + ((ky > -4) AND (py > 2))*"
    ASSERT >(adr_basic_skip_kugel1_make_visible) = >(adr_basic_dontskip_kugel1_make_visible)
        .ascnum3 <(adr_basic_skip_kugel1_make_visible)-<(adr_basic_dontskip_kugel1_make_visible)
adr_basic_dontskip_kugel1_make_visible:
        .asc ":"

; Make Kugel #1 visible:
        .basic " kx = 0 : ky = -2 : "

; Set sprite pointer for sprite #1:
        .basic 'POKE 2041, 138 - ((PEEK(53266) AND 31) < 8):'  ; Kugel oder Schlange

; Set sprite color for sprite #1:
        .basic 'POKE 53288, PEEK( '
        .ascnum4 basic_adr_kugel_colors
        .basic ' + (PEEK(53266) AND 3)) : '

; Kugel #1 Sprite coordinates: we use "tx" and "ty" for that.
; Re-calc tx and ty from initial values 172 / 72 and current values of kx and ky:
;;;     .basic " tx = 172 + 16*(kx+kx-ky) : ty = 72 + 16*ky : "
        .basic " tx = 172 : ty = 40 : "
        .basic " POKE 53250,172 : POKE 53251,40 : "

; Set $D002/$D003 and $D010 from tx and ty (and sx).
        .basic " POKE 53264,-2*(tx > 255) -(sx > 255) : POKE 53250,tx AND 255 : POKE 53251,ty : "
        .basic " POKE 53269,3 "  ; Enable Sprite #0 and #1

adr_basic_skip_kugel1_make_visible:

basic_adr_branch_to_kugel1_end_of_handler:
        .asc ":"

; Handling of Kugel #1 is done. Branch to end of handler:
        .basic " POKE 780, "
        .ascnum03 <(basic_adr_kugel1_end_of_handler)
        .basic " : POKE 782, "
        .ascnum02 >(basic_adr_kugel1_end_of_handler)
        .basic " : SYS 43108 "

adr_basic_skip_kugel1_invisible:
        .asc ":"

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 100

; Check if Kugel #1 has fallen off the board:
        .basic " POKE z, "
        .ascnum2 <(adr_basic_skip_kugel1_fallen)
        .basic " + (ky > 8)*"
    ASSERT >(adr_basic_skip_kugel1_fallen) = >(adr_basic_dontskip_kugel1_fallen)
        .ascnum2 <(adr_basic_skip_kugel1_fallen)-<(adr_basic_dontskip_kugel1_fallen)
adr_basic_dontskip_kugel1_fallen:
        .asc ":"

; Make Kugel #1 invisible:
        .basic " POKE 53269,1 : "   ; Disable Sprite #1, but keep Sprite #0 enabled.
        .basic " kx = 0 : ky = -9 : "  ; Adjust here: delay before Kugel #1 reappears

; Handling of Kugel #1 is done. Branch to end of handler:
        .basic " POKE 780, "
        .ascnum03 <(basic_adr_kugel1_end_of_handler)
        .basic " : POKE 782, "
        .ascnum02 >(basic_adr_kugel1_end_of_handler)
        .basic " : SYS 43108 "

adr_basic_skip_kugel1_fallen:
        .asc ":"

;  Move Kugel #1 one step.
        .basic " ky = ky + 1 : "
        .basic " kx = kx - (PEEK(53266) AND 1)*(ky > 0) : "

; Kugel #1 Sprite coordinates: we use "tx" and "ty" for that.
; Re-calc tx and ty from initial values 172 / 72 and current values of kx and ky:
        .basic " tx = 172 - 16*(kx+kx-ky) * (ky > 0) : ty = 72 + 16*ky : "

; Set $D002/$D003 and $D010 from tx and ty (and sx).
        .basic " POKE 53264,-2*(tx > 255) -(sx > 255) : POKE 53250,tx AND 255 : POKE 53251,ty : "

; Check if Kugel #1 has caught the player:
        .basic " POKE z, "
        .ascnum3 <(adr_basic_skip_kugel1_catch)
        .basic " + ((kx = px) AND (ky = py))*"
    ASSERT >(adr_basic_skip_kugel1_catch) = >(adr_basic_dontskip_kugel1_catch)
        .ascnum2 <(adr_basic_skip_kugel1_catch)-<(adr_basic_dontskip_kugel1_catch)
adr_basic_dontskip_kugel1_catch:
        .asc ":"

; Branch to handler of player falling off game board:
        .basic " POKE 780, "
        .ascnum03 <(basic_adr_player_fallen)
        .basic " : POKE 782, "
        .ascnum02 >(basic_adr_player_fallen)
        .basic " : SYS 43108 "

adr_basic_skip_kugel1_catch:

basic_adr_kugel1_end_of_handler:
        .asc ":"

; Read joystick in port #2:
        .basic " j = PEEK(p) "

; Bit 0..3: Direction up, down, left, right

;      j AND ... = 0
; Down+right: 10         =>  dy =  1,  dx = 1
; Down+left: 6           =>  dy =  1,  dx = 0
; Up+right: 9            =>  dy = -1,  dx = 0
; Up+left: 5             =>  dy = -1,  dx = -1

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 110

; Set sprite pointer for sprite #0 according to joystick pressed left or right:
        .basic ' sp = sp + (((j AND 8) = 0) AND sp = 137) : '
        .basic ' sp = sp - (((j AND 4) = 0) AND sp = 136) : '
        .basic 'POKE 2040,sp : '

; Evaluate joystick position:
        .basic "dx = ((j AND 5) = 0) - ((j AND 10) = 0) : "

        .basic "dy = dx + ((j AND 9) = 0) - ((j AND 6) = 0) : "

; Adjust px and py according to dx and dy:
        .basic " px = px + dx : py = py + dy : "

; Re-calc sx and sy from initial values 172 / 72 and current values of px and py:
        .basic " sx = 172 + 16*(px+px-py) : sy = 72 + 16*py : "

; Set $D000/$D001 and $D010 from sx and sy (and tx).
        .basic " POKE 53264,-2*(tx > 255) -(sx > 255) : POKE 53248,sx AND 255 : POKE 53249,sy "

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 120

; Check if player fell off the game board:
        .basic " POKE z, "
        .ascnum2 <(adr_basic_skip_fall)
        .basic " + (px < 0 OR py < 0 OR py > 8 OR px > py"

; or if the player has bumped into Kugel #1:
        .basic " OR ((kx = px) AND (ky = py))"

        .basic ")*"
        .ascnum2 <(adr_basic_skip_fall)-<(adr_basic_dontskip_fall)
adr_basic_dontskip_fall:
        .asc ":"
; Player just fell off the game board (or bumped into Kugel #1).
; Branch to handler:
        .basic " POKE 780, "
        .ascnum03 <(basic_adr_player_fallen)
        .basic " : POKE 782, "
        .ascnum02 >(basic_adr_player_fallen)
        .basic " : SYS 43108 "

        .basic ' :::::::: ' ; Waste some bytes

adr_basic_skip_fall:
        .basic " : "

    ASSERT >(adr_basic_dontskip_fall) = >(adr_basic_skip_fall)

; If the current field wasn't colored yet, set C(x,y) and count in CF:
        .basic " POKE z, "
        .ascnum2 <(adr_basic_inc_cf)
        .basic " - (c(px,py)=1)*"
        .ascnum3 <(adr_basic_dontinc_cf)-<(adr_basic_inc_cf)

adr_basic_inc_cf:
        .asc ":"

    ASSERT >(adr_basic_inc_cf) = >(adr_basic_dontinc_cf)

; The current field wasn't already colored. Color now:
        .basic " c(px,py) = 1 : cf = cf + 1 : sc = sc + cf "

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 130

; Print to $0400:
        .basic ' POKE648,4 : '
; Update current Score:
        .basic ' PRINT"{HOME,DOWN,BROWN}"SPC(30)sc : '

; Print to $3000:
        .basic ' POKE 648,48 : '

; Re-color on-screen game board field:
        .basic " POKE 646,cs : "  ; set new field color here
        .basic " PRINT y$(py) x$(px) t$"
        .by SEMICOLON

; If CF = 45, then all game board fields are colored. Level won!
        .basic " : POKE z, "
        .ascnum3 <(adr_basic_dontskip_levelwon)
        .basic " + (cf < 45)*"
        .ascnum1 <(adr_basic_dontskip_levelwon)-<(adr_basic_skip_levelwon)
    ASSERT >(adr_basic_skip_levelwon) = >(adr_basic_dontskip_levelwon)
adr_basic_skip_levelwon:

adr_basic_dontinc_cf:
        .basic " : "

; Loop forever
        .basic " NEXT "

adr_basic_dontskip_levelwon:
        .basic ":"
; All game board fields are colored. Level won!

        .basic " i = 9 : NEXT : "  ; Break out of forever-loop

; Print to $0400:
        .basic " POKE 648,4 : "

; Print Level completed
        .basic ' PRINT "{HOME,DOWN,DOWN,DOWN,LIGHT_GREEN}" SPC(7) "*** level" le "completed! ***" : '

; Print to $3000:
        .basic " POKE 648,48 "

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 140

; Turn off all Sprites except Sprite #0:
        .basic " POKE 53269,1 : "
    
        .basic ' FOR i = 1 TO 4 : '

; Paint all game board fields with alternating color:
        .basic ' POKE 646, (i AND 1) - 5 * (i > 3) : ' ; set color of game board fields here
        .basic ' FOR x = 8 TO 0 STEP -1 : FOR y = x TO 8 : PRINT y$(y)x$(x)t$'
        .by SEMICOLON
        .basic ' : '
        .basic ' NEXT : NEXT : NEXT : '

; Set Y = 0 for Sprite #0 to avoid flickering when starting next level:
        .basic " POKE 53249,0 : "

; Increase level (restarting at 1 after 99):
        .basic " le = 1 - (le < 99) * le : "

; Print to $0400:
        .basic " POKE 648,4 : "
        .basic ' PRINT "{HOME,DOWN,BROWN}" SPC(18) le "{LEFT} " : '

; Start next level:
        .basic " POKE 780, "
        .ascnum03 <(basic_adr_start_next_level)
        .basic " : POKE 782, "
        .ascnum02 >(basic_adr_start_next_level)
        .basic " : SYS 43108 "

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 150

basic_adr_player_fallen:
        .basic ":"

        .basic " i = 9 : NEXT : "  ; Break out of forever-loop

        .basic " FOR y = 0 TO 29 : POKE 53249, sy - PEEK(53249) : FOR i = 0 TO 79 : NEXT : NEXT : "

; Decrease number of lifes:
        .basic " li = li - 1 : "

; Print to $0400:
        .basic " POKE 648,4 : "
        .basic ' PRINT "{HOME,DOWN,BROWN}" SPC(6) li : '

; If last life is lost, game over.
        .basic " POKE z, "
        .ascnum3 <(adr_basic_dontskip_gameover)
        .basic " + (li > 0)*"
        .ascnum2 <(adr_basic_dontskip_gameover)-<(adr_basic_skip_gameover)

adr_basic_skip_gameover:
        .asc ":"

    ASSERT >(adr_basic_skip_gameover) = >(adr_basic_dontskip_gameover)

        .basic " POKE 780, "
        .ascnum03 <(basic_adr_restart_after_life_lost)
        .basic " : POKE 782, "
        .ascnum02 >(basic_adr_restart_after_life_lost)
        .basic " : SYS 43108 "

adr_basic_dontskip_gameover:
        .asc ":"

;  Turn Sprite #0 off; all others off.
        .basic " POKE53269,0 "

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 160

; Print "Game Over":
        .basic ' PRINT "{HOME,DOWN,DOWN,DOWN,YELLOW}" SPC(11) "*** game over ***" : '

; Update Highscore:
        .basic ' hi = hi + (sc > hi)*(hi-sc) : '

; Print Highscore:
        .basic ' PRINT"{HOME,GRAY1,DOWN,DOWN}" SPC(21) "hi-score:" hi : '

; Wait for joystick fire on port #2
        .basic ' WAIT p,16,16 : '

; Wait for joystick fire on port #2 to be released again
        .basic ' WAIT p,16 : '

; Clear "Game Over":
        .basic ' PRINT c$ : '

; Restart game in attract mode
        .basic " POKE 780, "
        .ascnum03 <(adr_basic_restart_attract)
        .basic " : POKE 782, "
        .ascnum02 >(adr_basic_restart_attract)
        .basic " : SYS 43108 "

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 170 ; line number

        .basic ' a$ = '
        .by 34
gfx_source_in_basic:
 .by 40    ; 40 bytes of data following:
 .by 1, 1, 1, 1, 2, 7, 31, 127, 2, 7, 31, 127, 255, 255, 255, 255
 .by 128, 224, 248, 254, 255, 255, 255, 255, 1, 1, 1, 1, 128, 224, 248, 254
 .by 127, 31, 7, 2, 1, 1, 1, 1

 .by 32+1  ; skip 32 bytes

 .by 24    ; 24 bytes of data following:
 .by 255, 255, 255, 255, 127, 31, 7, 2
 .by 255, 255, 255, 255, 254, 248, 224, 128, 254, 248, 224, 128, 1, 1, 1, 1

 .by 200+1 ; skip 200 bytes

 .by 128   ; 128 bytes of data following:
 .by 1, 207, 192, 1, 63, 240, 1, 14, 240, 1, 15, 245, 1, 63, 213, 1
 .by 235, 1, 15, 170, 240, 62, 234, 175, 235, 174, 171, 250, 170, 172, 14, 170
 .by 160, 58, 170, 176, 234, 170, 192, 235, 235, 1, 53, 59, 1, 5, 79, 1
 .by 85, 69, 20, 85, 69, 84, 20, 5, 85, 1, 5, 85, 1, 2, 80, 1

 .by 4, 243, 1, 15, 252, 1, 15, 176, 1, 95, 240, 1, 87, 252, 1, 1
 .by 235, 1, 15, 170, 240, 250, 171, 188, 234, 186, 235, 58, 170, 175, 10, 170
 .by 176, 14, 170, 172, 4, 170, 171, 1, 235, 235, 1, 236, 92, 1, 241, 80
 .by 20, 81, 85, 21, 81, 85, 85, 80, 20, 85, 80, 1, 5, 64, 1, 1

        .by 34

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 180 ; line number

        .basic ' a$ = '
        .by 34
 .by 0+1 ; skip 0 bytes
 .by 128    ; 128 bytes of data following:
 .by 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
 .by 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 170, 1, 2, 170
 .by 128, 6, 170, 160, 6, 170, 160, 6, 170, 160, 6, 170, 160, 14, 170, 144
 .by 6, 170, 160, 14, 170, 144, 13, 170, 176, 4, 106, 192, 1, 255, 1, 1

 .by 3, 170, 128, 10, 186, 168, 82, 170, 10, 1, 1, 5, 6, 170, 168, 26
 .by 170, 170, 25, 1, 58, 58, 85, 186, 14, 170, 202, 1, 1, 10, 1, 1
 .by 23, 26, 170, 160, 106, 170, 168, 100, 1, 232, 233, 86, 232, 58, 171, 40
 .by 1, 1, 40, 64, 1, 40, 234, 170, 160, 58, 170, 128, 15, 255, 1, 1

basic_adr_level_colors:
            .by $72
            .by $D4
            .by $36
            .by $D5
            .by $27
            .by $63
            .by $4D
            .by $5D

basic_adr_kugel_colors:
            .by 1
            .by $10
            .by 3
            .by 7

            .asc '{LIGHT_BLUE}'

        .by 34

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 190  ; line number

    .basic ' h$ = "'
    .asc '{13, 13, SHIFT_DISABLE, SHIFT_OUT}'
    .asc '{GRAY3}***{WHITE} B-Bert {GRAY3}***'
    .asc '{13, GRAY3}'
    .asc 'A mini-game written in BASIC'
    .by 13
    .asc 'in only 20 lines'
    .by 13
    .asc 'for the {WHITE}20 Zeilen BASIC Compo{GRAY3}'
    .by 13
    .asc 'of Forum64.de'
    .asc '{13, 13, LIGHT_BLUE}'
    .basic '"'

    .by 0
    .wo 38911 ; (dummy) pointer to next BASIC line
    .wo 200  ; line number

    .basic ' c$ = "{13, 13, SHIFT_DISABLE, SHIFT_OUT, GRAY3}'
    .asc 'Written by{YELLOW} Simon Stelling {GRAY3}(ssdsa)'
    .by 13
    .asc '07/2008'
    .by 13, 13
    .asc 'Contact: '
    .by 13
    .asc ' simon.stelling@gmx.de{13, 13, LIGHT_BLUE}"'

    .by 0

adr_basic_line_9999:
        .wo 0

end_of_basic_file:

; ========================================================================

PC $2000

gfx_start:

charset:
   ; first row:
        .by %........
        .by %........
        .by %........
        .by %........
        .by %.......X
        .by %.....XXX
        .by %...XXXXX
        .by %.XXXXXXX

        .by %.......X
        .by %.....XXX
        .by %...XXXXX
        .by %.XXXXXXX
        .by %XXXXXXXX
        .by %XXXXXXXX
        .by %XXXXXXXX
        .by %XXXXXXXX

        .by %X.......
        .by %XXX.....
        .by %XXXXX...
        .by %XXXXXXX.
        .by %XXXXXXXX
        .by %XXXXXXXX
        .by %XXXXXXXX
        .by %XXXXXXXX

        .by %........
        .by %........
        .by %........
        .by %........
        .by %X.......
        .by %XXX.....
        .by %XXXXX...
        .by %XXXXXXX.

   ; second row:
        .by %.XXXXXXX
        .by %...XXXXX
        .by %.....XXX
        .by %.......X
        .by %........
        .by %........
        .by %........
        .by %........

        .by %XXXXXXXX
        .by %XXXXXXXX
        .by %XXXXXXXX
        .by %XXXXXXXX
        .by %.XXXXXXX
        .by %...XXXXX
        .by %.....XXX
        .by %.......X

        .by %XXXXXXXX
        .by %XXXXXXXX
        .by %XXXXXXXX
        .by %XXXXXXXX
        .by %XXXXXXX.
        .by %XXXXX...
        .by %XXX.....
        .by %X.......

        .by %XXXXXXX.
        .by %XXXXX...
        .by %XXX.....
        .by %X.......
        .by %........
        .by %........
        .by %........
        .by %........

sprite_data_player:
        .by %m....,%mX.XX,%mX...
        .by %m....,%m.XXX,%mXX..
        .by %m....,%m..X#,%mXX..
        .by %m....,%m..XX,%mXX==
        .by %m....,%m.XXX,%mX===
        .by %m....,%mX##X,%m....
        .by %m..XX,%m####,%mXX..
        .by %m.XX#,%mX###,%m##XX
        .by %mX##X,%m##X#,%m###X
        .by %mXX##,%m####,%m##X.
        .by %m..X#,%m####,%m##..
        .by %m.X##,%m####,%m#X..
        .by %mX###,%m####,%mX...
        .by %mX##X,%mX##X,%m....
        .by %m.X==,%m.X#X,%m....
        .by %m..==,%m=.XX,%m....
        .by %m====,%m=.==,%m.==.
        .by %m====,%m=.==,%m===.
        .by %m.==.,%m..==,%m====
        .by %m....,%m..==,%m====
        .by %m....,%m...=,%m==..
        .by 0

sprite_data_player2:
        .by %m...X,%mXX.X,%m....
        .by %m..XX,%mXXX.,%m....
        .by %m..XX,%m#X..,%m....
        .by %m==XX,%mXX..,%m....
        .by %m===X,%mXXX.,%m....
        .by %m....,%mX##X,%m....
        .by %m..XX,%m####,%mXX..
        .by %mXX##,%m###X,%m#XX.
        .by %mX###,%m#X##,%mX##X
        .by %m.X##,%m####,%m##XX
        .by %m..##,%m####,%m#X..
        .by %m..X#,%m####,%m##X.
        .by %m...X,%m####,%m###X
        .by %m....,%mX##X,%mX##X
        .by %m....,%mX#X.,%m==X.
        .by %m....,%mXX.=,%m==..
        .by %m.==.,%m==.=,%m====
        .by %m.===,%m==.=,%m====
        .by %m====,%m==..,%m.==.
        .by %m====,%m==..,%m....
        .by %m..==,%m=...,%m....
        .by 0

sprite_data_ball:
        .by %m....,%m....,%m....
        .by %m....,%m....,%m....
        .by %m....,%m....,%m....
        .by %m....,%m....,%m....
        .by %m....,%m....,%m....
        .by %m....,%m....,%m....
        .by %m....,%m....,%m....
        .by %m....,%m....,%m....
        .by %m....,%m....,%m....
        .by %m....,%m####,%m....
        .by %m...=,%m####,%m#...
        .by %m..=#,%m####,%m##..
        .by %m..=#,%m####,%m##..
        .by %m..=#,%m####,%m##..
        .by %m..=#,%m####,%m##..
        .by %m..X#,%m####,%m#=..
        .by %m..=#,%m####,%m##..
        .by %m..X#,%m####,%m#=..
        .by %m..X=,%m####,%m#X..
        .by %m...X,%m=###,%mX...
        .by %m....,%mXXXX,%m....
        .by 0

sprite_data_snake:
        .by %m...#,%m####,%m#...
        .by %m..##,%m#X##,%m###.
        .by %m==.#,%m####,%m..##
        .by %m....,%m....,%m..==
        .by %m..=#,%m####,%m###.
        .by %m.=##,%m####,%m####
        .by %m.=#=,%m....,%m.X##
        .by %m.X##,%m====,%m#X##
        .by %m..X#,%m####,%mX.##
        .by %m....,%m....,%m..##
        .by %m....,%m....,%m.==X
        .by %m.=##,%m####,%m##..
        .by %m=###,%m####,%m###.
        .by %m=#=.,%m....,%mX##.
        .by %mX##=,%m===#,%mX##.
        .by %m.X##,%m###X,%m.##.
        .by %m....,%m....,%m.##.
        .by %m=...,%m....,%m.##.
        .by %mX###,%m####,%m##..
        .by %m.X##,%m####,%m#...
        .by %m..XX,%mXXXX,%m....
        .by 0

gfx_file_end:

; ========================================================================

DEFINE basic_file_size (end_of_basic_file-(file_start-2))

DEFINE gfx_file_size (gfx_file_end-gfx_start)

; ========================================================================

PRINT basic_file_size

PRINT gfx_file_size

; ========================================================================

; Now that everything is assembled, save to file:
SAVE file_start-2   end_of_basic_file   b-bert.prg
SAVE gfx_start      gfx_file_end        gfx.bin

